﻿Option Strict On

Imports Windows.Storage
Imports Windows.Storage.Streams

' 空白ページのアイテム テンプレートについては、http://go.microsoft.com/fwlink/?LinkId=234238 を参照してください

''' <summary>
''' それ自体で使用できる空白ページまたはフレーム内に移動できる空白ページ。
''' </summary>
Public NotInheritable Class ClaudiaShowPage
    Inherits Page

    ''' <summary>
    ''' このページがフレームに表示されるときに呼び出されます。
    ''' </summary>
    ''' <param name="e">このページにどのように到達したかを説明するイベント データ。Parameter 
    ''' プロパティは、通常、ページを構成するために使用します。</param>
    Protected Overrides Async Sub OnNavigatedTo(e As Navigation.NavigationEventArgs)
        Dim result As String
        Dim myStorageFolder As StorageFolder = Windows.Storage.KnownFolders.PicturesLibrary
        Dim mySubFolder = Await myStorageFolder.CreateFolderAsync("claudiaXML", CreationCollisionOption.OpenIfExists)
        Dim myFile = Await mySubFolder.GetFileAsync("claudiaInfo.xml")
        Using myStream As IRandomAccessStream = Await myFile.OpenAsync(FileAccessMode.Read)
            Using reader As StreamReader = New StreamReader(myStream.AsStream, System.Text.Encoding.UTF8)
                result = reader.ReadToEnd
            End Using
        End Using
        Dim doc As XElement = XElement.Parse(result)
        ClaudiaImage.Source = New BitmapImage(New Uri("ms-appx:///Images/" & doc.Descendants("Image").Value))
        MediaElement1.Source = New Uri("ms-appx:///WAV/" & doc.Descendants("Wav").Value)
    End Sub

    Private Sub playButton_Click(sender As Object, e As RoutedEventArgs) Handles playButton.Click
        MediaElement1.Play()
        playButton.IsEnabled = False
        stopButton.IsEnabled = True
    End Sub

    Private Sub stopButton_Click(sender As Object, e As RoutedEventArgs) Handles stopButton.Click
        MediaElement1.Stop()
        stopButton.IsEnabled = False
        playButton.IsEnabled = True
    End Sub
End Class
