﻿Option Strict On

Imports Windows.Storage
Imports Windows.Storage.Streams

' 空白ページのアイテム テンプレートについては、http://go.microsoft.com/fwlink/?LinkId=234238 を参照してください

''' <summary>
''' それ自体で使用できる空白ページまたはフレーム内に移動できる空白ページ。
''' </summary>
''' 
Structure ClaudiaInfo
    Property ClaudiaImage As String
    Property myWav As String
End Structure

Public NotInheritable Class MainPage
    Inherits Page
    Dim xmldoc As XElement
    Dim wavXmldoc As XElement
    Dim claudiaSelectedImage As String
    Dim wavSelectedFile As String
    Protected Overrides Async Sub OnNavigatedTo(e As Navigation.NavigationEventArgs)
        Dim myStorageFolder As StorageFolder = Windows.Storage.KnownFolders.PicturesLibrary
        Dim mySubFolder = Await myStorageFolder.CreateFolderAsync("claudiaXML", CreationCollisionOption.OpenIfExists)
        Dim myFile = Await mySubFolder.GetFilesAsync()
        If myFile.Count > 0 Then
            openButton.IsEnabled = True
        Else
            openButton.IsEnabled = False
        End If

        xmldoc = XElement.Load("claudia.xml")
        Dim myClaudiaInfo As New List(Of ClaudiaInfo)
        For Each result In From c In xmldoc.Descendants("Item") Select c
            With myClaudiaInfo
                .Add(New ClaudiaInfo With {.ClaudiaImage = "ms-appx:///Images/" & result.Attribute("small").Value})
            End With

        Next
        claudiaListBox.ItemsSource = myClaudiaInfo

        wavXmldoc = XElement.Load("sound.xml")
        Dim mySoundList As New List(Of ClaudiaInfo)
        For Each result In From c In wavXmldoc.Descendants("Item") Select c
            With mySoundList
                .Add(New ClaudiaInfo With {.myWav = result.Attribute("word").Value})
            End With

        Next
        wavListBox.ItemsSource = mySoundList
    End Sub

    Private Sub claudiaListBox_SelectionChanged(sender As Object, e As SelectionChangedEventArgs) Handles claudiaListBox.SelectionChanged
        If claudiaListBox.SelectedIndex >= 0 AndAlso wavListBox.SelectedIndex >= 0 Then
            saveButton.IsEnabled = True
        Else
            saveButton.IsEnabled = False
        End If
    End Sub

    Private Sub wavListBox_SelectionChanged(sender As Object, e As SelectionChangedEventArgs) Handles wavListBox.SelectionChanged
        If claudiaListBox.SelectedIndex >= 0 AndAlso wavListBox.SelectedIndex >= 0 Then
            saveButton.IsEnabled = True
        Else
            saveButton.IsEnabled = False
        End If
    End Sub

    Private Async Sub saveButton_Click(sender As Object, e As RoutedEventArgs) Handles saveButton.Click
        myFrame.Visibility = Windows.UI.Xaml.Visibility.Visible
        claudiaSelectedImage = xmldoc.Descendants("Item")(claudiaListBox.SelectedIndex).Attribute("Large").Value
        wavSelectedFile = wavXmldoc.Descendants("Item")(wavListBox.SelectedIndex).Attribute("wav").Value

        Dim saveXml As XElement = <Claudia><Image><%= claudiaSelectedImage %></Image><Wav><%= wavSelectedFile %></Wav></Claudia>
        Dim saveXmldoc As XElement = XElement.Parse(saveXml.ToString)
        Dim result As String = saveXmldoc.ToString

        Dim myStorageFolder As StorageFolder = Windows.Storage.KnownFolders.PicturesLibrary
        Dim mySubFolder = Await myStorageFolder.CreateFolderAsync("claudiaXML", CreationCollisionOption.OpenIfExists)
        Dim myXmlFile As StorageFile = Await mySubFolder.CreateFileAsync("claudiaInfo.xml", CreationCollisionOption.ReplaceExisting)

        Using myStream As IRandomAccessStream = Await myXmlFile.OpenAsync(FileAccessMode.ReadWrite)
            Dim writer As DataWriter = New DataWriter(myStream)
            writer.UnicodeEncoding = UnicodeEncoding.Utf8
            writer.WriteString(result)
            Await writer.StoreAsync
        End Using

        openButton.IsEnabled = True
        myFrame.Navigate(GetType(ClaudiaShowPage), Nothing)
    End Sub

    Private Sub backButton_Click(sender As Object, e As RoutedEventArgs) Handles backButton.Click
        myFrame.Visibility = Windows.UI.Xaml.Visibility.Collapsed
    End Sub

    Private Sub openButton_Click(sender As Object, e As RoutedEventArgs) Handles openButton.Click
        myFrame.Visibility = Windows.UI.Xaml.Visibility.Visible
        myFrame.Navigate(GetType(ClaudiaShowPage), Nothing)
    End Sub
End Class
